function isNumeric(n)
{
	if ( isNaN(n) && (n != ".") ) { return false; }
	else { return true; }
}

function subStr(s1,p1,p2)
{
	var rv = "";
	if ( p1 < 0 ) {p1 = 0}
	if ( p2 > s1.length-1 ) { p2 = s1.length-1 }
	if ( p1 > p2 ) {p2 = p1}
	var i = p1;
	
	while ( i <= p2 ) {
		rv = rv + s1.charAt(i);
		i = i + 1;
	}
			
	return rv;
}

function getTotalFree(whiteList)
{
	var totalFree = 0;
	var drvIndex = 0;
	var drvList = filesystem.volumes;
	for ( b in whiteList ) {
		drvIndex = 0;
		if ( whiteList[b] != "" ) {
			while ( whiteList[b] != drvList[drvIndex].path ) {
				drvIndex = drvIndex + 1;
				if ( drvIndex > drvList.length-1 ) {
					print("Error while searching for drive in drvLst");
					break;
				}
			}
			totalFree = totalFree + drvList[drvIndex].freeBytes;
		}
	}
	return totalFree;
}

function parseVal(st, capacity)
{
	var i = 0;
	var tmp = new Array();
	var sz = 0;
				
	if ( st != "" ) {
	s = st.toUpperCase();
//Remove Spaces
	s = s.replace(/ /g,"");
	s = s.replace(/,/g,".");
			

			
	while( isNumeric(s.charAt(i)) && (i<(s.length-1)) ) {
		i = i + 1;
	}
	//print("after searching: i="+i);

	if ( i > 0 ) {
		var snum = subStr(s,0,i-1);
		switch ( s.charAt(i) ) {
		case "G": 
			sz = Math.round(parseFloat(snum) * 1024 * 1024 * 1024);
			break
		case "M": 
			sz = Math.round(parseFloat(snum) * 1024 * 1024);
			break
		case "K": 
			sz = Math.round(parseFloat(snum) * 1024);
			break
		case "%":
			sz = Math.round(capacity * parseFloat(snum) / 100);
			break
		default: 
			sz = Math.Round(parseFloat(snum));
			break
		}
	}
	}
			
	return sz;
}


function hasElement(theArray,theString)
{
	var rv = false;

	if ( theArray.length > 0 ) {
		for(ar in theArray) {
			if ( theArray[ar] == theString ) {
				rv = true;
				break;
			}
		}
	}
	return rv;
}

function somethingHasChanged()
{
	var rv = false;
	var lastString = preferences.savedData.value;
	var thisString = "";
	var vols = filesystem.volumes;
	
	thisString = mWindow.hOffset + ";" + mWindow.vOffset;
	for (i in vols) {
		thisString = thisString + ";" + vols[i].path + ";" + vols[i].totalBytes + ";" + vols[i].freeBytes;
		}
	
	
	if ( lastString != thisString ) {
		rv = true;
		preferences.savedData.value = thisString;
	}
	
	return rv;
}