function upd(forceUpdate)
{

if ( forceUpdate || somethingHasChanged() ) {

suppressUpdates();
		
var vols = filesystem.volumes;
drvLbl = new Array();	//contains drive names (C:\;D:\...)
drvInfo = new Array();	//contains Information about free space
statBar = new Array();	//the bar that shows your used space
statBg = new Array();	//background for the bar
back = new Array();	//black background for each drive
var winSize = (preferences.windowSize.value / 10);	//scale index
var s = "";
var barColor;
var textColor;
			
var i = 0;
var hInd = 0;	//used for horizontal arrangement of drives
var hMax = 0;	//the maximum of hInd - used for main window size
var vInd = 0;	//used for vertical arrangement of drives
var vMax = 0;	//the maximum of vInd - used for main window size
var textLen = 0;
var arrageValue = 0;
var mTextLen = 250 * winSize;
var used = 0;
var freePerc = 0;
var usedPerc = 0;
var whiteList = new Array();
var openPath = "";
var highetstLabelNumber = 0;

i = 0;
whiteList = preferences.whiteList.value.split(";");

//This loop has to be done twice:
//first loop: Text labels are created to see if the labels 
//must be expanded
//second loop: all the rest of the work is done

for ( a in vols ) {
			
	if ( (whiteList[0] == "") || (hasElement(whiteList,vols[a].path)) ) {
			
		if ( vols[a].totalBytes != 0 ) {

			if ( (vols[a].freeBytes != 0) || (preferences.showZeroByte.value == "1") ) {
				
				drvLbl[i] = new Text();
				drvLbl[i].size = Math.round(30 * winSize);
				drvLbl[i].style="normal";
				if ( preferences.nameFormat.value == "path" ) {
					drvLbl[i].data = vols[a].path;
				} else {
					drvLbl[i].data = filesystem.getDisplayName(vols[a].path);
				}
				
				freePerc = Math.round(100 * vols[a].freeBytes / vols[a].totalBytes);
				s = "";
				
				if (preferences.showPercent.value == "1") {
					s = s + freePerc + "%";
				}

				if (preferences.showBytes.value == "1") {
					s = s + "  " + bytesToUIString(vols[a].freeBytes);
				}
					
			
				drvInfo[i] = new Text();
				drvInfo[i].size = Math.round(30 * winSize);
				drvInfo[i].style="normal";
				drvInfo[i].alignment = "right";
				drvInfo[i].data = s;
				
				textLen = drvLbl[i].width + (25*winSize) + drvInfo[i].width;
				if ( mTextLen < textLen ) { mTextLen = textLen; }

				i++;
			}
		}
	}
}
//end of 1st loop			
	
	highetstLabelNumber = i-1;
	i = 0;

//begin of 2nd loop			
for ( a in vols ) {
		
	if ( (whiteList[0] == "") || (hasElement(whiteList,vols[a].path)) ) {
			
		if ( vols[a].totalBytes != 0 ) {
				
			if ( (vols[a].freeBytes != 0) || (preferences.showZeroByte.value == "1") ) {
				
				used = vols[a].totalBytes - vols[a].freeBytes;
				usedPerc = Math.round(100 * used / vols[a].totalBytes);
				freePerc = Math.round(100 * vols[a].freeBytes / vols[a].totalBytes);

			//get color settings for text and graph
	
				barColor = preferences.graphColor.value;
				textColor = preferences.fontColor.value;
				
				if ( preferences.changeColor.value == "1" ) { 
					var critical = parseVal(preferences.lowValue.value,vols[a].totalBytes);

					if ( (critical != 0) && (vols[a].freeBytes < critical) ) {
						var changeWhat = parseInt(preferences.lowOption.value);
						
						if ( (changeWhat & 1) == 1 ) {
							barColor = preferences.lowColor.value;
						}
						if ( (changeWhat & 2) == 2 ) {
							textColor = preferences.lowColor.value;
						}

					}
				}

				drvLbl[i].color = textColor;
				drvInfo[i].color = textColor;

			//Create information labels for each drive
				
				back[i] = new Image();
				back[i].src = "resources/background.png";
				if ( preferences.showGraph.value == "1" ) {
					back[i].height = Math.round(100 * winSize);
				} else {
					back[i].height = Math.round(75 * winSize);
				}
				back[i].width = Math.round(mTextLen + (40 * winSize));//300 * winSize);
				back[i].zOrder = -2;
				
				if ( preferences.openDrive.value == "1" ) {
					//back[i].onMouseUp = "filesystem.open(\"" + vols[a].path + "\\\");";
					//back[i].onMouseUp = "filesystem.open(\"" + convertPathToPlatform(vols[a].path) + "\");";
					openPath = "\""+vols[a].path;
					if ( system.platform == "windows" ) {openPath = openPath + "\\";}
					openPath = openPath + "\"";
					back[i].onMouseUp = "filesystem.open(" + openPath + ");";
				}
				
				
				statBar[i] = new Image();
				statBar[i].src="resources/pixel"+preferences.graphStyle.value+".png";
				statBar[i].height = Math.round(18 * winSize);
				switch (preferences.graphMode.value) {
					case "2": statBar[i].width = Math.round(mTextLen * freePerc/100);
						break;
					default: statBar[i].width = Math.round(mTextLen * usedPerc/100);//2.5 * winSize * usedPerc);
						break;
				}
				statBar[i].colorize = barColor;
				
				
				
				statBg[i] = new Image();
				statBg[i].src="resources/pixel"+preferences.graphStyle.value+"bg.png";
				statBg[i].height = statBar[i].height;
				statBg[i].width = mTextLen;//2.5 * winSize * 100);
				statBg[i].colorize = preferences.graphBackColor.value;
				statBg[i].zOrder = -1;
								
		
			//arrange labels

				back[i].hOffset = Math.round(hInd * back[i].width);
				back[i].vOffset = Math.round(vInd * back[i].height);
			
				drvLbl[i].hOffset = Math.round(20 * winSize + ( hInd * back[i].width));
				drvLbl[i].vOffset = Math.round(20 * winSize + ( vInd * back[i].height) + drvLbl[i].size);

				drvInfo[i].hOffset = drvLbl[i].hOffset + statBg[i].width;
				drvInfo[i].vOffset = drvLbl[i].vOffset;

		
				if ( preferences.showGraph.value == "1" ) {
					statBar[i].hOffset = drvLbl[i].hOffset;
					statBar[i].vOffset = drvLbl[i].vOffset + 15*winSize;

					statBg[i].hOffset = statBar[i].hOffset;
					statBg[i].vOffset = statBar[i].vOffset;
				} else {
					delete statBar[i];
					delete statBg[i]; 
				}			
				
				
			//count up rows and/or columns if it's not the last loop
				
				if ( i < highetstLabelNumber ) {
					if (preferences.driveOrder.value == "v") {
						vInd = vInd + 1;
						arrangeValue = (vInd+1) * back[i].height;
						if ( preferences.autoArrange.value == "1" ) { arrangeValue = arrangeValue + mWindow.vOffset; }
						if (arrangeValue  > screen.availTop + screen.availHeight) {
							hInd = hInd + 1;
							vInd = 0;
						}
					} else {
						hInd = hInd + 1;
						arrangeValue = (hInd+1) * back[i].width;
						if ( preferences.autoArrange.value == "1" ) { arrangeValue = arrangeValue + mWindow.hOffset; }
						if (arrangeValue  > screen.availLeft + screen.availWidth) {
							vInd = vInd + 1;
							hInd = 0;
						}
					}
				

				//save maximums
					if (hInd > hMax) {hMax = hInd;}
					if (vInd > vMax) {vMax = vInd;}
					i = i + 1;
				}
			}
		}
	}
}
//end of 2nd loop

//set main window size
mWindow.width = (hMax+1) * back[i].width;
mWindow.height = (vMax+1) * back[i].height;

resumeUpdates();

}

}