function snap(r)
{
	var snapRadius = r;

	if ( mWindow.hOffset < (screen.availLeft+snapRadius) ) {
		mWindow.hOffset = screen.availLeft;
	}
	
	if ( (mWindow.hOffset+mWindow.width) > (screen.availLeft+screen.availWidth-snapRadius) ) {
		mWindow.hOffset = screen.availLeft+screen.availWidth-mWindow.width;
	}
	
	if ( mWindow.vOffset < (screen.availTop+snapRadius) ) {
		mWindow.vOffset = screen.availTop;
	}
	
	if ( (mWindow.vOffset+mWindow.height) > (screen.availTop+screen.availHeight-snapRadius) ) {
		mWindow.vOffset = screen.availTop+screen.availHeight-mWindow.height;
	}
}

function initTimer()
{
	timer1.interval = preferences.timerInterval.value / 10;

	////////////////////////////////
	//hardcore setting: for testing only!
	//timer1.interval = 0.1;
	////////////////////////////////
	timer1.reset();
}

function updDrv()
{
	var drvLst = filesystem.volumes;
	var whiteList = preferences.whiteList.value.split(";");
	var drvNames = new Array();
	var formFields = Array();
	var i = 0;
	var wLs = "";
	var allSelected = false;
	
	for (a in drvLst) {
		if ( drvLst[a].totalBytes != 0 ) {
					//i++;
			formFields[i] = new FormField();
			formFields[i].name = "drv"+i;
			formFields[i].type = "checkBox";
			formFields[i].title = drvLst[a].path;
					
			if ( hasElement(whiteList,drvLst[a].path) ) {
				formFields[i].value = "1";
			} else {
				formFields[i].value = "0";
			}

			drvNames[i] = drvLst[a].path;
			i++;
		}
	}
	formFields[i] = new FormField();
	formFields[i].name = "drvAll";
	formFields[i].type = "checkBox";
	formFields[i].title = "All (overrides settings above)";
	if ( whiteList[0] == "" ) {
		formFields[i].value = "1";
	} else {
		formFields[i].value = "0";
	}
	formFields[i].description = "Select the drives you want to be shown. If you deselect all checkboxes, all drives are shown.";

	formResult = form(formFields,"Drives whitelist","OK");

	if ( formResult != null ) {
		for ( a in whiteList ) { delete(whiteList[a]); }
				
		whiteList[0] = "";
		if ( formResult[i] != "1" ) {
			i = 0;
			for ( a in formResult ) {
				if ( formResult[a] == "1" ) {
					whiteList[i] = drvNames[a];
					i = i + 1;
				}
			}
		}
		if (whiteList[0] == "" ) { allSelected = true; }
		for ( a in whiteList ) { if( whiteList[a] == "" || whiteList[a] == ";" ) {delete(whiteList[a]);}}
				
		if (! allSelected ) {
			if ( preferences.showZeroByte.value == "0" ) {
					
				if ( getTotalFree(whiteList) == 0 && whiteList[0] != "" ) {
					preferences.showZeroByte.value = "1";
					savePreferences();
					alert("All drives you have chosen to show have 0 bytes free. The \"Show drives with 0 bytes free\" preference has been activated.");
				}
			}
		}
			
		if( allSelected ) {wLs = "";}else{wLs = whiteList.join(";");}
		preferences.whiteList.value = wLs;
		savePreferences();
		upd(true);
	}
}